include "HJConst.JSH"
include "HJGlobal.JSH"
include "Common.JSM"
include "EasyReader.JSM"

; Dolphin Easy Reader scripts prepared by Hartgen Consultancy February 2020.
; Note that the scripts were written following a brief examination of EasyReader version 8. Hartgen Consultancy cannot guarantee that the entire application is accessible to JAWS.
; Suitable for JAWS version 18 and beyond.

Globals
string capture,
Int Found

Script ScriptFileName()
ScriptAndAppNames (msgAppName)
EndScript

; Search Dialog

Script Search ()
let Found = 1 ; for Virtual Cursor at a later time.
TypeCurrentScriptKey ()
; JAWS does not announce the window name here so we'll tell the user what it is.
Say (MSGSearch, OT_USER_REQUESTED_INFORMATION)

EndScript

; The Virtual Buffer has difficulty in locating a search phrase in the book. We will deal with that here.

Script SwitchFocusArea ()
if found == 1 then 
let capture = GetObjectName (true, 0) ; we have what the user wants to search for in the buffer.
TypeCurrentScriptKey ()
pause ()
FindString (getfocus(), capture, s_top, s_unrestricted, true)
stopspeech ()
PerformScript SayLine ()
let found = 0 ; so the user can switch to app areas without continual searching.
else
TypeCurrentScriptKey ()
EndIf

EndScript
; So the user can play audio from within the text of the virtual buffer.

int function PreProcessKeyPressedEvent(int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
if nKey == Key_SpaceBar
&& IsVirtualPCCursor () then 
TypeCurrentScriptKey ()
endif

EndFunction

; There are parts of the application which could be important to review in a controlled environment.

Script VirtualiseControl ()
var
String SControl
if DialogActive () then  ; we want the window, such as Book Information Dialog.
let SControl = GetTextInWindow(GetRealWindow(GetCurrentWindow()))
else ; just the control
let SControl = GetObjectName (true, 0)
EndIf
SayFormattedMessage (Ot_User_Buffer, SControl+cscBufferNewLine+cscBufferNewLine+cMsgBuffExit)

EndScript

; Help text.

script WindowKeysHelp ()
var string help = msgWindowKeysHelp+cscBufferNewLine+cscBufferNewLine+cMsgBuffExit
sayMessage (OT_USER_BUFFER, help)
endScript

script HotkeyHelp()
var string help = MSGHotkeyHelp+cscBufferNewLine+cscBufferNewLine+cMsgBuffExit
sayMessage (OT_USER_BUFFER, help)
endScript